package ru.dbotthepony.kstarbound.world.entities

import ru.dbotthepony.kstarbound.GlobalDefaults
import ru.dbotthepony.kstarbound.defs.ActorMovementParameters
import ru.dbotthepony.kstarbound.defs.MovementParameters
import ru.dbotthepony.kstarbound.defs.player.ActorMovementModifiers
import ru.dbotthepony.kstarbound.world.Direction
import ru.dbotthepony.kstarbound.world.World
import ru.dbotthepony.kstarbound.world.physics.Poly
import ru.dbotthepony.kvector.vector.Vector2d

class EntityActorMovementController(val entity: Entity) : AbstractActorMovementController() {
	override val world: World<*, *> by entity::world
	override var position: Vector2d by entity::position
	override var actorMovementParameters: ActorMovementParameters = GlobalDefaults.actorMovementParameters

	override var lastControlDown: Boolean = false
	override var fallThroughSustain: Int = 0
	override var targetHorizontalAmbulatingVelocity: Double = 0.0

	override var controlRun: Boolean = false
	override var controlCrouch: Boolean = false
	override var controlDown: Boolean = false
	override var controlFly: Vector2d? = null
	override var isFlying: Boolean = false
	override var isFalling: Boolean = false
	override var canJump: Boolean = true
	override var controlJump: Boolean = false
	override var isGroundMovement: Boolean = false
	override var isLiquidMovement: Boolean = false
	override var controlPathMove: Pair<Vector2d, Boolean>? = null
	override var pathMoveResult: Pair<Vector2d, Boolean>? = null
	override var controlMove: Direction? = null
	override var movementModifiers: ActorMovementModifiers = ActorMovementModifiers.EMPTY

	override var controlActorMovementParameters: ActorMovementParameters = ActorMovementParameters.EMPTY
	override var controlMovementModifiers: ActorMovementModifiers = ActorMovementModifiers.EMPTY

	override var isOnGround: Boolean = false
	override var isColliding: Boolean = false
	override var isCollisionStuck: Boolean = false
	override var isCollidingWithNull: Boolean = false
	override var stickingDirection: Double? = null
	override var surfaceSlope: Vector2d = Vector2d.ZERO
	override var surfaceVelocity: Vector2d = Vector2d.ZERO
	override var collisionCorrection: Vector2d = Vector2d.ZERO
	override var liquidPercentage: Double = 0.0
	override var appliedForceRegion: Boolean = false
	override var isZeroGravity: Boolean = false

	override var controlRotationRate: Double = 0.0
	override var controlAcceleration: Vector2d = Vector2d.ZERO
	override var controlForce: Vector2d = Vector2d.ZERO
	override var rotation: Double = 0.0

	override var lastControlCrouch: Boolean = false
	override var controlFace: Direction? = null
	override var isRunning: Boolean = false
	override var isWalking: Boolean = false
	override var isCrouching: Boolean = false
	override var isJumping: Boolean = false
	override var lastControlJump: Boolean = false
	override var controlJumpAnyway: Boolean = false
	override val approachVelocities: MutableList<ApproachVelocityCommand> = ArrayList()
	override val approachVelocityAngles: MutableList<ApproachVelocityAngleCommand> = ArrayList()
	override var movingDirection: Direction? = null
	override var facingDirection: Direction? = null
	override var anchorEntity: Entity? = null
}
